#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

=begin
	unzip_sjis.rb ver 0.0.1
	unzipコマンドを利用して、sjisのファイル名を使ったzipを文字化けしないように解凍するツール（たぶん）
=end
require 'nkf'
require 'gtk2'

$c_files = []		#変換するファイルリスト
$flag_conv = false	#変換処理を実行中かどうかのフラグ

#Gladeファイル読み込み
builder = Gtk::Builder.new
builder.add_from_file("unzip_sjis.glade")

#ーーーーー　メインウィンドウ系ウィジェット　ーーーーー
@window = builder["window1"]
@lbl_dir = builder["label_dir"]

@btn_quit = builder["btn_quit"]
@btn_open = builder["btn_open"]
@btn_conv = builder["btn_conv"]
@btn_conv.sensitive = false

@view_log = builder["textview1"]
@buf_log = builder["textbuffer1"]

@spin = builder["spinner1"]
@Vbox_spin = builder["Vbox_spin"]

#ーーーーー　ファイル選択ダイアログ系ウィジェット　ーーーーー
@dialog_f_select = builder["filechooserdialog1"]
@btn_f_ok = builder["btn_ok"]
@btn_f_cancel = builder["btn_cancel"]

#ーーーーー　メインウィンドウ終了系　ーーーーー
@window.signal_connect("delete-event") do
	#unzip_killer()	#終了する前に、unzipが動いていたら強制終了
	false	#下のdestroyイベントにお渡し（ここにGtk.main_quitを書いて終了させても良いのかもしれないけど…）
end
@window.signal_connect("destroy") do
	Gtk.main_quit
end

#ーーーーー　終了ボタンが押されたら　ーーーーー
@btn_quit.signal_connect("clicked") do
	unzip_killer()
	Gtk.main_quit
end

#ーーーーー　変換ボタンが押されたらん　ーーーーー
@btn_conv.signal_connect("clicked") do
	if $c_files.size > 0 then
		if $flag_conv == false then
			@btn_conv.label = "✕停止(_E)"
			$flag_conv = true
			@spin.active = true
			@Vbox_spin.show
			th_cnvt( $c_files )
		else	#解凍処理中なら……
			@t2.kill
			$flag_conv = false
			r = unzip_killer()
			if r then
				view_txt("	unzip終了")
			end
			@spin.active = false
			@Vbox_spin.hide
			@btn_conv.label = "○解凍(_E)"
			view_txt("＊＊＊＊＊　強制停止　＊＊＊＊＊")
		end
	else
		@btn_conv.sensitive = false
	end
end


#フォルダ選択ダイアログ系
@btn_open.signal_connect("clicked") do
	@dialog_f_select.show
end

#ファイル選択ダイアログのOKボタンが押された
@btn_f_ok.signal_connect("clicked") do
	sel_dir = @dialog_f_select.filenames[0]
	if sel_dir != nil then
		if File.ftype(sel_dir) == "directory" then
			@lbl_dir.text = sel_dir
			chk_zips( sel_dir )
			else
			@lbl_dir.text = ""
		end
	end
	@dialog_f_select.hide
end

#ファイル選択ダイアログのクローズ
@btn_f_cancel.signal_connect("clicked") do
	@dialog_f_select.hide
end

#ファイル選択ダイアログがescキーなどで不意に破棄されるのを防止
@dialog_f_select.signal_connect("delete_event") do
	@dialog_f_select.hide
	true
end

def chk_zips(d)		#指定したディレクトリからzipファイルを抽出
	$c_files = Dir::glob("#{d}/*.zip")
	if $c_files.size > 0 then
		$c_files.each {|f|
			view_txt( File::basename( f ) )
		}
		view_txt( "	以上　#{$c_files.size}　個" )
		@btn_conv.sensitive = true
	else
		view_txt( "	ソコに〜、私（zip）はいません〜♪\n" )
		@btn_conv.sensitive = false
	end
end

#変換処理スレッドん
def th_cnvt(f)
	@t2 = Thread.new(f) do
		if @lbl_dir.text != "" then
			o_d = "-d '#{@lbl_dir.text}'"
		else
			o_d = ""
		end
		f.each{|z|
			uz_cmd = "unzip -o -O cp932 '#{z}' #{o_d}"
			view_txt( uz_cmd )
			r = `#{uz_cmd}`
			#下の２行は、sijsのファイル名をUTF8に変換して表示させようと思ったんだけど
			#unzipコマンドが返す処理結果自体が文字化けしているので、上手くいかないみたい……残念
			r_to_u = NKF.nkf('-w -m0', r)	#なので念の為にUTF8に変換しているだけって状態です
			view_txt( r_to_u )
		}
		$flag_conv = false
		view_txt("ーーーーー　作成終了　ーーーーー")
		@spin.active = false
		@Vbox_spin.hide
		@btn_conv.label = "○解凍(_E)"
	end
end


#ーーーーー　似非ログ表示　ーーーーー
def view_txt(t)
	if t == "" then
		@buf_log.text = ""
	else
		@buf_log.text += "#{t}\n"
	end
	@view_log.move_cursor(Gtk::MOVEMENT_PAGES, 1, false)	#一番最後のページにスクロールを移動
end

#unzipを強制終了
def unzip_killer()
	s_word = "unzip -o -O"
	r = `ps u`
	pid = 0
	r.each_line do |line|
		if line.include?(s_word) then
			a = line.split(/\s* \s*/)	#psの結果から、半角スペースを区切り文字として、値を配列に格納
			a.each do |b|
				if b.to_i > 0 then
					pid = b.to_i
					r = `kill #{pid}`
#					view_txt("kill #{pid}")
					break
				end
			end
		end
	end
	if pid > 0 then
		return true		#unzipの実行を強制終了させたよんフラグ
	else
		return false	#funzipは実行されてなかったよんフラグ
	end
end

#ーーーーー　メインウィンドウの表示　ーーーーー
@window.show_all
@Vbox_spin.hide
#@dialog_f_select.show

Gtk.main
#お疲れ様でした

